searchData={"content_type":"text/markdown","items":[{"doc":"Jet plugin SDK for elixir.","ref":"JetPluginSDK.html","title":"JetPluginSDK","type":"module"},{"doc":"SDK 提供了一套 behaviour 抽象用来实现插件的生命周期功能，只需实现 behaviour 中\n定义的回调函数即可。\n\n```elixir\ndefmodule JetSamplePlugin.Tenant do\n  use JetPluginSDK.TenantMan.Tenants.Tenant\n\n  @impl JetPluginSDK.TenantMan.Tenants.Tenant\n  def handle_install(_tenant) do\n    {:ok, %{}}\n  end\n\n  @impl JetPluginSDK.TenantMan.Tenants.Tenant\n  def handle_run({_tenant, tenant_state}) do\n    {:noreply, tenant_state}\n  end\nend\n```","ref":"JetPluginSDK.html#module-tenant","title":"Tenant - JetPluginSDK","type":"module"},{"doc":"插件运行过程中有时需要调用 Jet 的相关接口，这些接口的调用都通过 JetClient 发\n起。想要让 JetClient 正常工作，需要为 JetCLient 提供相应的配置：\n\n```elixir\nconfig :jet_plugin_sdk, JetPluginSDK.JetClient,\n  endpoint: \"http://plugin.jet.local/graphql\",\n  access_key: \"t/lnVHUw89Vgd+sW\"\n```","ref":"JetPluginSDK.html#module-jetclient","title":"JetClient - JetPluginSDK","type":"module"},{"doc":"应用启动时可以自动从 Jet 获取插件的实例，并启动相应的 tenants，通过以下配置完成：\n\n```elixir\nconfig :jet_plugin_sdk, JetPluginSDK.TenantMan,\n  warm_up: [tenant_module: JetSamplePlugin.Tenant]\n```","ref":"JetPluginSDK.html#module-warmup","title":"Warmup - JetPluginSDK","type":"module"},{"doc":"","ref":"JetPluginSDK.html#fetch_tenant_info/2","title":"JetPluginSDK.fetch_tenant_info/2","type":"function"},{"doc":"Converts a map to a capability struct.","ref":"JetPluginSDK.API.CapabilityNormalizer.html","title":"JetPluginSDK.API.CapabilityNormalizer","type":"module"},{"doc":"","ref":"JetPluginSDK.API.CapabilityNormalizer.html#run/2","title":"JetPluginSDK.API.CapabilityNormalizer.run/2","type":"function"},{"doc":"This module helps to define the GraphQL API schema for Jet plugins.","ref":"JetPluginSDK.API.GraphQL.html","title":"JetPluginSDK.API.GraphQL","type":"behaviour"},{"doc":"```elixir\ndefmodule MySchema do\n  use JetPluginSDK.API.GraphQL,\n    query_fields: [\n      do:\n        field :some_query, type: :string do\n          resolve &__MODULE__.some_query/2\n        end\n    ],\n    mutation_fields: [\n      do:\n        field :some_mutation, type: :string do\n          resolve &__MODULE__.some_mutation/2\n        end\n    ]\n\n  # define input_object for plugin_config\n  plugin_config do\n    field :foo, :string\n  end\n\n  @impl JetPluginSDK.API.GraphQL\n  def initialize(_args, _resolution) do\n    # implement initialize here\n  end\n\n  @impl JetPluginSDK.API.GraphQL\n  def install(_args, _resolution) do\n    # implement install here\n  end\n\n  @impl JetPluginSDK.API.GraphQL\n  def update(_args, _resolution) do\n  # implement update here\n  end\n\n  @impl JetPluginSDK.API.GraphQL\n  def uninstall(_args, _resolution) do\n    # implement uninstall here\n  end\n\n  @impl JetPluginSDK.API.GraphQL\n  def health_check(_args, _resolution) do\n    # implement health check here\n  end\nend\n```","ref":"JetPluginSDK.API.GraphQL.html#module-define-schema","title":"define schema - JetPluginSDK.API.GraphQL","type":"behaviour"},{"doc":"```elixir\ndefmodule MySchema do\n  use JetPluginSDK.API.GraphQL,\n    tenant_module: MyApp.Tenant\n\n  plugin_config do\n    field :foo, :string\n  end\nend\n```","ref":"JetPluginSDK.API.GraphQL.html#module-generate-callbacks-via-setting-tenant_module","title":"generate callbacks via setting tenant_module - JetPluginSDK.API.GraphQL","type":"behaviour"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#c:health_check/2","title":"JetPluginSDK.API.GraphQL.health_check/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#c:initialize/2","title":"JetPluginSDK.API.GraphQL.initialize/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#c:install/2","title":"JetPluginSDK.API.GraphQL.install/2","type":"callback"},{"doc":"Jet should call `jet_plugin_install` and `jet_plugin_update` with config defined in this type.\n\n```elixir\n  plugin_config do\n    field :foo, :string\n  end\n```","ref":"JetPluginSDK.API.GraphQL.html#plugin_config/1","title":"JetPluginSDK.API.GraphQL.plugin_config/1","type":"macro"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#c:uninstall/2","title":"JetPluginSDK.API.GraphQL.uninstall/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#c:update/2","title":"JetPluginSDK.API.GraphQL.update/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#t:callback_response/0","title":"JetPluginSDK.API.GraphQL.callback_response/0","type":"type"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#t:callback_response_async/0","title":"JetPluginSDK.API.GraphQL.callback_response_async/0","type":"type"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#t:callback_response_error/0","title":"JetPluginSDK.API.GraphQL.callback_response_error/0","type":"type"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#t:callback_response_ok/0","title":"JetPluginSDK.API.GraphQL.callback_response_ok/0","type":"type"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#t:capability/0","title":"JetPluginSDK.API.GraphQL.capability/0","type":"type"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#t:database_capability/0","title":"JetPluginSDK.API.GraphQL.database_capability/0","type":"type"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#t:initialize_response/0","title":"JetPluginSDK.API.GraphQL.initialize_response/0","type":"type"},{"doc":"","ref":"JetPluginSDK.API.GraphQL.html#t:manifest/0","title":"JetPluginSDK.API.GraphQL.manifest/0","type":"type"},{"doc":"This client returns empty instances and ignores all events.","ref":"JetPluginSDK.JetClient.Blackhole.html","title":"JetPluginSDK.JetClient.Blackhole","type":"module"},{"doc":"","ref":"JetPluginSDK.JetClient.Blackhole.html#new/0","title":"JetPluginSDK.JetClient.Blackhole.new/0","type":"function"},{"doc":"","ref":"JetPluginSDK.JetClient.Blackhole.html#t:t/0","title":"JetPluginSDK.JetClient.Blackhole.t/0","type":"type"},{"doc":"The Tenant module.","ref":"JetPluginSDK.Tenant.html","title":"JetPluginSDK.Tenant","type":"module"},{"doc":"","ref":"JetPluginSDK.Tenant.html#build_tenant_id/1","title":"JetPluginSDK.Tenant.build_tenant_id/1","type":"function"},{"doc":"","ref":"JetPluginSDK.Tenant.html#build_tenant_id/3","title":"JetPluginSDK.Tenant.build_tenant_id/3","type":"function"},{"doc":"","ref":"JetPluginSDK.Tenant.html#split_tenant_id/1","title":"JetPluginSDK.Tenant.split_tenant_id/1","type":"function"},{"doc":"","ref":"JetPluginSDK.Tenant.html#t:capabilities/0","title":"JetPluginSDK.Tenant.capabilities/0","type":"type"},{"doc":"","ref":"JetPluginSDK.Tenant.html#t:config/0","title":"JetPluginSDK.Tenant.config/0","type":"type"},{"doc":"","ref":"JetPluginSDK.Tenant.html#t:id/0","title":"JetPluginSDK.Tenant.id/0","type":"type"},{"doc":"","ref":"JetPluginSDK.Tenant.html#t:state/0","title":"JetPluginSDK.Tenant.state/0","type":"type"},{"doc":"","ref":"JetPluginSDK.Tenant.html#t:t/0","title":"JetPluginSDK.Tenant.t/0","type":"type"},{"doc":"The capabilities that Jet provides to plugins.","ref":"JetPluginSDK.Tenant.Capability.html","title":"JetPluginSDK.Tenant.Capability","type":"behaviour"},{"doc":"","ref":"JetPluginSDK.Tenant.Capability.html#from_graphql_args/1","title":"JetPluginSDK.Tenant.Capability.from_graphql_args/1","type":"function"},{"doc":"","ref":"JetPluginSDK.Tenant.Capability.html#c:from_graphql_args/1","title":"JetPluginSDK.Tenant.Capability.from_graphql_args/1","type":"callback"},{"doc":"","ref":"JetPluginSDK.Tenant.Capability.html#from_json/1","title":"JetPluginSDK.Tenant.Capability.from_json/1","type":"function"},{"doc":"","ref":"JetPluginSDK.Tenant.Capability.html#c:from_json/1","title":"JetPluginSDK.Tenant.Capability.from_json/1","type":"callback"},{"doc":"","ref":"JetPluginSDK.Tenant.Capability.html#t:t/0","title":"JetPluginSDK.Tenant.Capability.t/0","type":"type"},{"doc":"The database capability.","ref":"JetPluginSDK.Tenant.Capability.Database.html","title":"JetPluginSDK.Tenant.Capability.Database","type":"module"},{"doc":"","ref":"JetPluginSDK.Tenant.Capability.Database.html#t:t/0","title":"JetPluginSDK.Tenant.Capability.Database.t/0","type":"type"},{"doc":"The config that is defined by the plugin.","ref":"JetPluginSDK.Tenant.Config.html","title":"JetPluginSDK.Tenant.Config","type":"module"},{"doc":"","ref":"JetPluginSDK.Tenant.Config.html#from_json/1","title":"JetPluginSDK.Tenant.Config.from_json/1","type":"function"},{"doc":"","ref":"JetPluginSDK.Tenant.Config.html#t:t/0","title":"JetPluginSDK.Tenant.Config.t/0","type":"type"},{"doc":"The source of truth for tenant data.","ref":"JetPluginSDK.TenantMan.Storage.html","title":"JetPluginSDK.TenantMan.Storage","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"JetPluginSDK.TenantMan.Storage.html#child_spec/1","title":"JetPluginSDK.TenantMan.Storage.child_spec/1","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.Storage.html#fetch/2","title":"JetPluginSDK.TenantMan.Storage.fetch/2","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.Storage.html#fetch!/2","title":"JetPluginSDK.TenantMan.Storage.fetch!/2","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.Storage.html#insert/2","title":"JetPluginSDK.TenantMan.Storage.insert/2","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.Storage.html#start_link/1","title":"JetPluginSDK.TenantMan.Storage.start_link/1","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.Storage.html#storage_name/1","title":"JetPluginSDK.TenantMan.Storage.storage_name/1","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.Storage.html#update!/2","title":"JetPluginSDK.TenantMan.Storage.update!/2","type":"function"},{"doc":"The `JetPluginSDK.TenantMan` module provides a behaviour for implementing\na tenant management supervisor.","ref":"JetPluginSDK.TenantMan.html","title":"JetPluginSDK.TenantMan","type":"behaviour"},{"doc":"defmodule MyTenant do\n      @moduledoc false\n\n      use JetPluginSDK.TenantMan\n\n      @spec ping(GenServer.server()) :: :pong\n      def ping(server) do\n        GenServer.call(server, :ping)\n      end\n\n      @impl JetPluginSDK.TenantMan\n      def handle_install(_tenant) do\n        {:ok, %{}}\n      end\n\n      @impl JetPluginSDK.TenantMan\n      def handle_run({_tenant, tenant_state}) do\n        {:ok, tenant_state}\n      end\n\n      @impl JetPluginSDK.TenantMan\n      def handle_call(:ping, _from, state) do\n        {:reply, :pong, state}\n      end\n    end","ref":"JetPluginSDK.TenantMan.html#module-example","title":"Example - JetPluginSDK.TenantMan","type":"behaviour"},{"doc":"children = [\n      MyTenant\n    ]\n\n    Supervisor.start_link(children, strategy: :one_for_all)","ref":"JetPluginSDK.TenantMan.html#module-usage","title":"Usage - JetPluginSDK.TenantMan","type":"behaviour"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#fetch_tenant/2","title":"JetPluginSDK.TenantMan.fetch_tenant/2","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#fetch_tenant!/2","title":"JetPluginSDK.TenantMan.fetch_tenant!/2","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:handle_call/3","title":"JetPluginSDK.TenantMan.handle_call/3","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:handle_cast/2","title":"JetPluginSDK.TenantMan.handle_cast/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:handle_continue/2","title":"JetPluginSDK.TenantMan.handle_continue/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:handle_info/2","title":"JetPluginSDK.TenantMan.handle_info/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:handle_install/1","title":"JetPluginSDK.TenantMan.handle_install/1","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:handle_run/1","title":"JetPluginSDK.TenantMan.handle_run/1","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:handle_uninstall/1","title":"JetPluginSDK.TenantMan.handle_uninstall/1","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:handle_update/2","title":"JetPluginSDK.TenantMan.handle_update/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#install/3","title":"JetPluginSDK.TenantMan.install/3","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#c:terminate/2","title":"JetPluginSDK.TenantMan.terminate/2","type":"callback"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#uninstall/2","title":"JetPluginSDK.TenantMan.uninstall/2","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#update/3","title":"JetPluginSDK.TenantMan.update/3","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#whereis/2","title":"JetPluginSDK.TenantMan.whereis/2","type":"function"},{"doc":"","ref":"JetPluginSDK.TenantMan.html#t:tenant_module/0","title":"JetPluginSDK.TenantMan.tenant_module/0","type":"type"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}